#ifndef MAPVIEWER_H
#define MAPVIEWER_H

#include "qcustomplot.h"
#include <Eigen/Dense>
#include <vector>
#include <map>
#include <iostream>
#include <math.h>
#include <mutex>

#include <QPixmap>
#include <QLabel>
#include "chartform.h"

using namespace std;

class MapViewer: public QObject {
    Q_OBJECT

public:

    void Init(QCustomPlot *customPlot_, QCustomPlot *_customPlot2);
    std::mutex mtx_ui;
    void SetOdomFocus()
    {
        std::lock_guard<std::mutex> lock(mtx_ui);
        odo_focused = !odo_focused;
    }

    void Show3DQuaternion(QWidget* _p);

    void PlotLine(QVector<QCPCurveData> dataSpiral, QColor _color, int _width);
    void PlotLine_c(QVector<QCPCurveData> dataSpiral, QColor _color, int _width);
    void PlotLines(QVector<QCPCurveData> dataSpiral, QColor _color, int _width, int id);
    void plotOdo(double x, double y, double heading);
    void PlotPoints(QVector<QCPCurveData> dataSpiral, QColor _color);
private:

    void SetBackGround(QCustomPlot * customPlot);
    void SetHostCorners();
    QCustomPlot *customPlot;
    QCustomPlot *customPlot_2;



    vector<Eigen::Vector2d> m_host_corner;
    map<int, QCPCurve *> vehicle_shp;
    QCPCurve *odo_curve;
    QCPCurve * center_line;

    bool odo_focused{false};

    ChartForm *chartForm;
    bool chartForm_flag = false;

};

#endif // MAPVIEWER_H
